create table company
(
 companyID TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
 companyName VARCHAR(64) NOT NULL DEFAULT ' ',
 companyFounded DATE NOT NULL DEFAULT '0000-00-00',
 companyEnd DATE NOT NULL DEFAULT '0000-00-00',
 companyOwnership ENUM('PRIVATE','PUBLIC') NOT NULL DEFAULT 'PRIVATE',
 companyCEO INT UNSIGNED NOT NULL DEFAULT '0',
 companyCFO INT UNSIGNED NOT NULL DEFAULT '0',
 companyCIO INT UNSIGNED NOT NULL DEFAULT '0',
 companyCOO INT UNSIGNED NOT NULL DEFAULT '0',
 companyWeb VARCHAR(32) NOT NULL DEFAULT ' ',
 companyEmail VARCHAR(24) NOT NULL DEFAULT ' ',
 companyLastChange DATE NOT NULL DEFAULT '0000-00-00',
 companyLastChangeBy INT UNSIGNED NOT NULL DEFAULT '0',
 companyValid ENUM('Y','N') NOT NULL DEFAULT 'N',
 PRIMARY KEY(companyID,companyLastChangeBy)
);

create table companyOffice
(
 officeID SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
 officeOfCompanyID TINYINT UNSIGNED NOT NULL DEFAULT '0',
 officeStatus ENUM('HEADQUARTER','BRANCH') NOT NULL DEFAULT 'HEADQUARTER',
 officeRegHourOpen TIME NOT NULL DEFAULT '00:00:00',
 officeRegHourClose TIME NOT NULL DEFAULT '00:00:00',
 officeRegWorkDay VARCHAR(7) UNSIGNED NOT NULL DEFAULT '1234567',
 officeFounded DATE NOT NULL DEFAULT '0000-00-00',
 officeActive ENUM('Y','N') DEFAULT 'Y',
 officeAddr VARCHAR(32) NOT NULL DEFAULT ' ',
 officeCity VARCHAR(16) NOT NULL DEFAULT ' ',
 officeCountry VARCHAR(24) NOT NULL DEFAULT ' ',
 officeLastChange DATE NOT NULL DEFAULT '0000-00-00',
 officeLastChangeBy INT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(officeID,officeOfCompanyID)
);

create table companyOfficeContact
(
 officeContactID INT UNSIGNED NOT NULL AUTO_INCREMENT,
 officeContactPhone VARCHAR(14) NOT NULL DEFAULT ' ',
 officeContactFax VARCHAR(14) NOT NULL DEFAULT ' ',
 officeContactOf SMALLINT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(officeContactID,officeContactOf)
);

create table companyRules
(
 rulesKey TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
 rulesWorkHours TINYINT UNSIGNED NOT NULL DEFAULT '8',
 rulesSickDays TINYINT UNSIGNED NOT NULL DEFAULT '3',
 rulesVacationDays TINYINT UNSIGNED NOT NULL DEFAULT '14',
 rulesOfCompanyID TINYINT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(rulesKey,rulesOfCompanyID)
);

create table companyPolicies
(
 policiesKey TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
 policiesDebtLength TINYINT(2) UNSIGNED NOT NULL DEFAULT '14',
 policiesRegCustMonthly TINYINT(1) UNSIGNED NOT NULL DEFAULT '2',
 policiesRegCustYearly TINYINT(2) UNSIGNED NOT NULL DEFAULT '24',
 policiesBlackListOrder TINYINT(2) UNSIGNED NOT NULL DEFAULT '10',
 policiesBlackListAmt DOUBLE(12,2) UNSIGNED NOT NULL DEFAULT '0.00',
 policiesBlackListAmtCurr VARCHAR(3) NOT NULL DEFAULT 'IDR',
 policiesYearlyDepreciation DOUBLE(4,2) UNSIGNED NOT NULL DEFAULT '0.10',
 policiesMaturityPaymentWeekly TINYINT(2) UNSIGNED NOT NULL DEFAULT '2',
 policiesLastChange DATE NOT NULL DEFAULT '0000-00-00',
 policiesLastChangeByID INT UNSIGNED NOT NULL DEFAULT '0',
 policiesOfCompanyID TINYINT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(policiesKey,policiesOfCompanyID)
);
