create table sales 
(
 salesKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 salesHandleBy INT UNSIGNED NOT NULL DEFAULT '0',
 salesOfficeID INT UNSIGNED NOT NULL DEFAULT '0',
 salesCustID INT UNSIGNED NOT NULL DEFAULT '0',
 salesCustContID INT UNSIGNED NOT NULL DEFAULT '0',
 salesDate DATE NOT NULL DEFAULT '0000-00-00', 
 salesType ENUM('AIR','TRAIN','SHIP') NOT NULL DEFAULT 'AIR',
 salesState ENUM('RECEIVED','PROCESS','CANCEL','REFUND') NOT NULL DEFAULT 'RECEIVED', 
 salesMethod ENUM('PICKUP','DELIVERY') NOT NULL DEFAULT 'PICKUP',
 salesPayState ENUM('PARTIAL','FULL','OWE','NON') NOT NULL DEFAULT 'NON', 
 salesChangeStateBy INT UNSIGNED NOT NULL DEFAULT '0',
 salesChangeStateDT DATE NOT NULL DEFAULT '0000-00-00',
 salesAmount DOUBLE(12,2) NOT NULL DEFAULT '0.00',
 salesCurrency CHAR(3) NOT NULL DEFAULT 'IDR',
 salesNote VARCHAR(64) NOT NULL DEFAULT ' ',
 PRIMARY KEY(salesKey,salesHandleBy)
);

create table orderAir
(
 orderAirKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 orderAirState VARCHAR(24) NOT NULL DEFAULT 'RECEIVED',
 orderAirSalesType ENUM('DOMESTIC','INTERNATIONAL') NOT NULL DEFAULT 'DOMESTIC',
 orderAirFullPrice DOUBLE(12,2) NOT NULL DEFAULT '0.00',
 orderAirFPCurr CHAR(3) NOT NULL DEFAULT 'IDR',
 orderAirDisc DOUBLE(4,2) NOT NULL DEFAULT '0.00',
 orderAirDiscAmt DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderAirDACurr CHAR(3) NOT NULL DEFAULT 'IDR',
 orderAirComm DOUBLE(4,2) NOT NULL DEFAULT '0.00',
 orderAirCommAmt DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderAirCACurr CHAR(3) NOT NULL DEFAULT 'IDR',
 orderSalesKey INT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(orderAirKey,orderSalesKey)
); 

create table orderStatusTable 
(
 orderStatusTableKey INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
 orderLastStatus VARCHAR(10) NOT NULL DEFAULT ' ',
 orderReceived VARCHAR(20) NOT NULL DEFAULT ' ',
 orderRecByID INT UNSIGNED NOT NULL DEFAULT '0',
 orderBooked VARCHAR(20) NOT NULL DEFAULT ' ',
 orderBookedByID INT UNSIGNED NOT NULL DEFAULT '0',
 orderReserved VARCHAR(20) NOT NULL DEFAULT ' ',
 orderReservedByID INT UNSIGNED NOT NULL DEFAULT '0',
 orderOk VARCHAR(20) NOT NULL DEFAULT ' ',
 orderOkByID INT UNSIGNED NOT NULL DEFAULT '0',
 orderIssued VARCHAR(20) NOT NULL DEFAULT ' ',
 orderIssuedByID INT UNSIGNED NOT NULL DEFAULT '0',
 orderCancel VARCHAR(20) NOT NULL DEFAULT ' ',
 orderCancelByID INT UNSIGNED NOT NULL DEFAULT '0',
 orderRefund VARCHAR(20) NOT NULL DEFAULT ' ',
 orderRefundByID INT UNSIGNED NOT NULL DEFAULT '0'
);

create table orderAirTicket
(
 orderAirTicketKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 orderAirKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderStatusKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderPassangerName VARCHAR(32) NOT NULL DEFAULT ' ',
 orderPassangerType ENUM('A','I','C','S') NOT NULL DEFAULT 'A',
 orderPassangerAge TINYINT UNSIGNED NOT NULL DEFAULT '0',
 orderRoute VARCHAR(36) NOT NULL DEFAULT ' ',
 orderTicketNumber VARCHAR(24) NOT NULL DEFAULT ' ',
 orderTicketAirAbbr VARCHAR(3) NOT NULL DEFAULT ' ',
 orderTicketDeptTime TIME NOT NULL DEFAULT '00:00:00',
 orderTicketDeptDate DATE NOT NULL DEFAULT '0000-00-00',
 orderTicketFlight VARCHAR(16) NOT NULL DEFAULT ' ',
 orderTicketType ENUM('OW','RT') NOT NULL DEFAULT 'OW',  
 orderTicketClass VARCHAR(2) NOT NULL DEFAULT 'Y',
 orderTicketPrice DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderTicketCurrency VARCHAR(3) NOT NULL DEFAULT 'IDR',
 orderTicketState ENUM('NOT_ISSUED','ISSUED','VOID') NOT NULL DEFAULT 'NOT_ISSUED',
 orderTicketStock ENUM('OWN','OTHER') NOT NULL DEFAULT 'OWN',
 orderTicketProvidedBy INT UNSIGNED NOT NULL DEFAULT '0',
 orderTicketLGKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderTicketNote VARCHAR(64) NOT NULL DEFAULT ' ',
 PRIMARY KEY(orderAirTicketKey,orderAirKey)
);

create table salesCustomer
(
 salesCustKey INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
 salesCustName VARCHAR(32) NOT NULL DEFAULT ' ',
 salesCustType ENUM('CORP','TR_AGENT','GOVT','HOTEL','REG','ONE_TIME') 
 NOT NULL DEFAULT 'ONE_TIME',
 salesCustBlackList ENUM('Y','N') DEFAULT 'N',
 salesCustAddrKey INT UNSIGNED NOT NULL DEFAULT '0',
 salesCustNote VARCHAR(32) NOT NULL DEFAULT ' '
);

create table salesCustContPerson
(
 salesCustContPersonKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 salesCustContPerName VARCHAR(32) NOT NULL DEFAULT ' ',
 salesCustKey INT UNSIGNED NOT NULL DEFAULT '0',
 salesCustContNote VARCHAR(32) NOT NULL DEFAULT ' ',
 salesCustContAddKey INT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(salesCustContPersonKey,salesCustKey)
);

create table salesCustAddr
(
 salesCustAddrKey INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, 
 salesCustAddr VARCHAR(32) NOT NULL DEFAULT ' ',
 salesCustAddrCity VARCHAR(16) NOT NULL DEFAULT 'JAKARTA',
 salesCustAddrCountry VARCHAR(16) NOT NULL DEFAULT 'INDONESIA'
);

create table salesCustContact
(
 salesCustContKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 salesCustPhone VARCHAR(14) NOT NULL DEFAULT ' ',
 salesCustHandPhone VARCHAR(14) NOT NULL DEFAULT ' ',
 salesCustFax VARCHAR(14) NOT NULL DEFAULT ' ', 
 salesCustCPKey INT UNSIGNED NOT NULL DEFAULT '0',
 salesCustKey INT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(salesCustContKey,salesCustContPersonKey)
);

create table orderTrain
(
 orderTrainKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 orderSalesKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderTrainStatus INT UNSIGNED NOT NULL DEFAULT '0',
 orderTrainState VARCHAR(24) NOT NULL DEFAULT 'RECEIVED',
 orderTrainNumber VARCHAR(32) NOT NULL DEFAULT ' ',
 orderTrainName VARCHAR(32) NOT NULL DEFAULT ' ',
 orderTrainCustName VARCHAR(32) NOT NULL DEFAULT ' ',
 orderTrainRoute VARCHAR(36) NOT NULL DEFAULT ' ',
 orderTrainLeaveTime TIME NOT NULL DEFAULT '00:00:00',
 orderTrainLeaveDate DATE NOT NULL DEFAULT '0000-00-00', 
 orderTrainStation VARCHAR(24) NOT NULL DEFAULT ' ',
 orderTrainDisc DOUBLE(4,2) NOT NULL DEFAULT '0.00',
 orderTrainDiscAmt DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderTrainTktState ENUM('NOT_ISSUED','ISSUED','VOID') NOT NULL DEFAULT 'NOT_ISSUED',
 orderTrainTktStock ENUM('OWN','OTHER') NOT NULL DEFAULT 'OWN',
 orderTrainTktProvidedBy INT UNSIGNED NOT NULL DEFAULT 'O',
 orderTrainTktLGKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderTrainNote VARCHAR(64) NOT NULL DEFAULT ' ',
 PRIMARY KEY(orderTrainKey,orderSalesKey)
);

create table orderShip
(
 orderShipKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 orderSalesKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderShipStatus INT UNSIGNED NOT NULL DEFAULT '0',
 orderShipState VARCHAR(24) NOT NULL DEFAULT 'RECEIVED',
 orderShipNumber VARCHAR(32) NOT NULL DEFAULT ' ',
 orderShipName VARCHAR(32) NOT NULL DEFAULT ' ',
 orderShipCustName VARCHAR(32) NOT NULL DEFAULT ' ',
 orderShipRoute VARCHAR(36) NOT NULL DEFAULT ' ',
 orderShipLeaveTime TIME NOT NULL DEFAULT '00:00:00',
 orderShipLeaveDate DATE NOT NULL DEFAULT '0000-00-00',
 orderShipPort VARCHAR(24) NOT NULL DEFAULT ' ',
 orderShipFullPrice DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderShipFPCurr VARCHAR(3) NOT NULL DEFAULT 'IDR',
 orderShipDisc DOUBLE(4,2) NOT NULL DEFAULT '0.00',
 orderShipDiscAmt DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderShipTktState ENUM('NOT_ISSUED','ISSUED','VOID') NOT NULL DEFAULT 'NOT_ISSUED',
 orderShipTktStock ENUM('OWN','OTHER') NOT NULL DEFAULT 'OWN',
 orderShipTktProvidedBy INT UNSIGNED NOT NULL DEFAULT '0',
 orderShipTktLGKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderShipNote VARCHAR(64) NOT NULL DEFAULT ' ',
 PRIMARY KEY(orderShipKey,orderSalesKey)
);

create table orderOther
(
 orderOtherKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 orderOtherSalesKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderOtherStatusKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderOtherState VARCHAR(24) NOT NULL DEFAULT 'RECEIVED',
 orderOtherType VARCHAR(32) NOT NULL DEFAULT ' ',
 orderOtherDesc VARCHAR(100) NOT NULL DEFAULT ' ',
 orderOtherDocNumber VARCHAR(32) NOT NULL DEFAULT ' ',
 orderOtherCustKey INT UNSIGNED NOT NULL DEFAULT ' ',
 orderOtherLGKey INT UNSIGNED NOT NULL DEFAULT '0',
 orderOtherFullPrice DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderOtherFPCurr VARCHAR(3) NOT NULL DEFAULT 'IDR',
 orderOtherDisc DOUBLE(4,2) NOT NULL DEFAULT '0.00',
 orderOtherDiscAmt DOUBLE(10,2) NOT NULL DEFAULT '0.00',
 orderOtherNote VARCHAR(64) NOT NULL DEFAULT ' ',
 PRIMARY KEY(orderOtherKey,orderOtherSalesKey)
);
 
create table salesPayment
(
 salesPaymentKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 salesPaymentDate DATE NOT NULL DEFAULT '0000-00-00',
 salesPaymentTime TIME NOT NULL DEFAULT '00:00:00',
 salesKey INT UNSIGNED NOT NULL DEFAULT '0',
 salesPaymentRecBy INT UNSIGNED NOT NULL DEFAULT '0',
 salesPaymentAmount DOUBLE(12,2) NOT NULL DEFAULT '0.00',
 salesPaymentCurr VARCHAR(3) NOT NULL DEFAULT 'IDR',
 salesVerifyBy INT UNSIGNED NOT NULL DEFAULT '0',
 salesVerifyDate DATE NOT NULL DEFAULT '0000-00-0',
 salesVerifyTime TIME NOT NULL DEFAULT '00:00:00',
 PRIMARY KEY(salesPaymentKey,salesKey,salesPaymentRecBy,salesVerifyBy)
);

create table salesPaymentType
(
 salesPaymentTypeKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 salesPaymentType ENUM('CASH','CREDIT_CARD','DEBIT_CARD','GIRO','CHEQUE') NOT NULL
 DEFAULT 'CASH',
 salesPaymentName VARCHAR(32) NOT NULL DEFAULT ' ',
 salesPaymentBank VARCHAR(32) NOT NULL DEFAULT ' ',
 salesPaymentCardExp DATE NOT NULL DEFAULT '0000-00-00',
 salesPaymentDocNum VARCHAR(32) NOT NULL DEFAULT ' ',
 salesPaymentMature  DATE NOT NULL DEFAULT '0000-00-00',
 salesPayKey INT UNSIGNED NOT NULL DEFAULT '0',
 PRIMARY KEY(salesPaymentTypeKey,salesPayKey)
);

create table salesLetterOfGuarantee
(
 salesLGKey INT UNSIGNED NOT NULL AUTO_INCREMENT,
 salesLGOrigin ENUM('ISSUE','RECEIVED') NOT NULL DEFAULT 'RECEIVED',
 salesLGNum VARCHAR(32) NOT NULL DEFAULT ' ',
 salesLGCompanyName VARCHAR(32) NOT NULL DEFAULT ' '
 salesLGCompanyPName VARCHAR(32) NOT NULL DEFAULT ' ',
 salesLGHandleBy INT UNSIGNED NOT NULL DEFAULT '0',
 salesLGAmount DOUBLE(10,2) UNSIGNED NOT NULL DEFAULT '0.00',
 salesLGCurr VARCHAR(3) NOT NULL DEFAULT 'IDR',
 salesLGDate DATE NOT NULL DEFAULT '0000-00-00',
 salesLGTime TIME NOT NULL DEFAULT '00:00:00',
 PRIMARY KEY(salesLGKey,salesLGHandleBy)
);
